/////////////////////////////////////////////////////////////////////////////
// ChangeColumns.cpp

#include "stdafx.h"
#include "App.h"
#include "ChangeColumns.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChangeColumns dialog

CChangeColumns::CChangeColumns(CWnd* pParent /*=NULL*/)
	: CDialog(CChangeColumns::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangeColumns)
	//m_strSvrAddr = _T("");

	//   : , , .
	GColumnsName	= TRUE;
	GColumnsFrags	= TRUE;
	GColumnsPing	= TRUE;
	
	// , .
	/*
	GColumnsTeam	= TRUE;
	GColumnsMesh	= TRUE;
	GColumnsSkin	= TRUE;
	GColumnsFace	= TRUE;
	GColumnsID		= TRUE;
	*/

	//  ,    "".
	m_bColumnsName	= GColumnsName;
	m_bColumnsFrags	= GColumnsFrags;
	m_bColumnsPing	= GColumnsPing;
	
	m_bColumnsTeam	= GColumnsTeam;
	m_bColumnsMesh	= GColumnsMesh;
	m_bColumnsSkin	= GColumnsSkin;
	m_bColumnsFace	= GColumnsFace;
	m_bColumnsID	= GColumnsID;

	//}}AFX_DATA_INIT
}

void CChangeColumns::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangeColumns)
	DDX_Control(pDX, IDC_CHECK_NAME, m_btCheckName);
	DDX_Control(pDX, IDC_CHECK_FRAGS, m_btCheckFrags);
	DDX_Control(pDX, IDC_CHECK_PING, m_btCheckPing);
	DDX_Control(pDX, IDC_CHECK_TEAM, m_btCheckTeam);
	DDX_Control(pDX, IDC_CHECK_MESH, m_btCheckMesh);
	DDX_Control(pDX, IDC_CHECK_SKIN, m_btCheckSkin);
	DDX_Control(pDX, IDC_CHECK_FACE, m_btCheckFace);
	DDX_Control(pDX, IDC_CHECK_ID, m_btCheckID);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChangeColumns, CDialog)
	//{{AFX_MSG_MAP(CChangeColumns)
	ON_BN_CLICKED(IDC_CHECK_TEAM, &CChangeColumns::OnCheckTeam)
	ON_BN_CLICKED(IDC_CHECK_MESH, &CChangeColumns::OnCheckMesh)
	ON_BN_CLICKED(IDC_CHECK_SKIN, &CChangeColumns::OnCheckSkin)
	ON_BN_CLICKED(IDC_CHECK_FACE, &CChangeColumns::OnCheckFace)
	ON_BN_CLICKED(IDC_CHECK_ID, &CChangeColumns::OnCheckID)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeColumns message handlers

void CChangeColumns::OnCancel()
{
	GColumnsName	= m_bColumnsName;
	GColumnsFrags	= m_bColumnsFrags;
	GColumnsPing	= m_bColumnsPing;
	
	GColumnsTeam	= m_bColumnsTeam;
	GColumnsMesh	= m_bColumnsMesh;
	GColumnsSkin	= m_bColumnsSkin;
	GColumnsFace	= m_bColumnsFace;
	GColumnsID		= m_bColumnsID;

	ColumnVisible(INDEX_TEAM, GColumnsTeam);
	ColumnVisible(INDEX_MESH, GColumnsMesh);
	ColumnVisible(INDEX_SKIN, GColumnsSkin);
	ColumnVisible(INDEX_FACE, GColumnsFace);
	ColumnVisible(INDEX_ID, GColumnsID);

	CDialog::OnCancel();
}

void CChangeColumns::OnOK() 
{
	CDialog::OnOK();
}

BOOL CChangeColumns::OnInitDialog() 
{
	CDialog::OnInitDialog();

	//
	//  : , , .
	//
	m_btCheckName.SetCheck(GColumnsName);
	m_btCheckFrags.SetCheck(GColumnsFrags);
	m_btCheckPing.SetCheck(GColumnsPing);

	m_btCheckName.EnableWindow(FALSE);
	m_btCheckFrags.EnableWindow(FALSE);
	m_btCheckPing.EnableWindow(FALSE);

	//CButton* pName=(CButton *)GetDlgItem(IDC_CHECK_NAME);
	//pName->SetCheck(GColumnsName);
	//pName->EnableWindow(FALSE);

	//CButton* pFrags=(CButton *)GetDlgItem(IDC_CHECK_FRAGS);
	//pFrags->SetCheck(GColumnsFrags);
	//pFrags->EnableWindow(FALSE);

	//CButton* pPing=(CButton *)GetDlgItem(IDC_CHECK_PING);
	//pPing->SetCheck(GColumnsPing);
	//pPing->EnableWindow(FALSE);

	//
	// , .
	//
	m_btCheckTeam.SetCheck(GColumnsTeam);
	m_btCheckMesh.SetCheck(GColumnsMesh);
	m_btCheckSkin.SetCheck(GColumnsSkin);
	m_btCheckFace.SetCheck(GColumnsFace);
	m_btCheckID.SetCheck(GColumnsID);

	//CButton* pTeam=(CButton *)GetDlgItem(IDC_CHECK_TEAM);
	//pTeam->SetCheck(m_bTeam);
	//pTeam->EnableWindow(m_bTeam);

	//CButton* pMesh=(CButton *)GetDlgItem(IDC_CHECK_MESH);
	//pMesh->SetCheck(m_bMesh);
	//pMesh->EnableWindow(m_bMesh);

	//CButton* pSkin=(CButton *)GetDlgItem(IDC_CHECK_SKIN);
	//pSkin->SetCheck(m_bSkin);
	//pSkin->EnableWindow(m_bSkin);

	//CButton* pFace=(CButton *)GetDlgItem(IDC_CHECK_FACE);
	//pFace->SetCheck(m_bFace);
	//pFace->EnableWindow(m_bFace);

	//CButton* pID=(CButton *)GetDlgItem(IDC_CHECK_ID);
	//pID->SetCheck(m_bID);
	//pID->EnableWindow(m_bID);

	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
// OnCheckTeam

void CChangeColumns::OnCheckTeam()
{
	if( m_btCheckTeam.GetCheck() )
	{
		//  .
		GColumnsTeam = TRUE;
		ColumnVisible(INDEX_TEAM, GColumnsTeam);
	}
	else
	{
		//  .
		GColumnsTeam = FALSE;
		ColumnVisible(INDEX_TEAM, GColumnsTeam);
	}
}

////////////////////////////////////////////////////////////////////////////////
// OnCheckMesh

void CChangeColumns::OnCheckMesh()
{
	if( m_btCheckMesh.GetCheck() )
	{
		//  .
		GColumnsMesh = TRUE;
		ColumnVisible(INDEX_MESH, GColumnsMesh);
	}
	else
	{
		//  .
		GColumnsMesh = FALSE;
		ColumnVisible(INDEX_MESH, GColumnsMesh);
	}
}

////////////////////////////////////////////////////////////////////////////////
// OnCheckSkin

void CChangeColumns::OnCheckSkin()
{
	if( m_btCheckSkin.GetCheck() )
	{
		//  .
		GColumnsSkin = TRUE;
		ColumnVisible(INDEX_SKIN, GColumnsSkin);
	}
	else
	{
		//  .
		GColumnsSkin = FALSE;
		ColumnVisible(INDEX_SKIN, GColumnsSkin);
	}
}

////////////////////////////////////////////////////////////////////////////////
// OnCheckFace

void CChangeColumns::OnCheckFace()
{
	if( m_btCheckFace.GetCheck() )
	{
		//  .
		GColumnsFace = TRUE;
		ColumnVisible(INDEX_FACE, GColumnsFace);
	}
	else
	{
		//  .
		GColumnsFace = FALSE;
		ColumnVisible(INDEX_FACE, GColumnsFace);
	}
}

////////////////////////////////////////////////////////////////////////////////
// OnCheckID

void CChangeColumns::OnCheckID()
{
	if( m_btCheckID.GetCheck() )
	{
		//  .
		GColumnsID = TRUE;
		ColumnVisible(INDEX_ID, GColumnsID);
	}
	else
	{
		//  .
		GColumnsID = FALSE;
		ColumnVisible(INDEX_ID, GColumnsID);
	}
}

////////////////////////////////////////////////////////////////////////////////
//    .

void CChangeColumns::ColumnVisible(int nColumn, BOOL bVisible)
{
	CMainFrame* pFrame = DYNAMIC_DOWNCAST(CMainFrame, AfxGetApp()->m_pMainWnd);
	if( pFrame )
	{
		// Get a pointer to the container view.
		CAppView* pContView = DYNAMIC_DOWNCAST(CAppView, pFrame->GetActiveView());
		if( pContView )
		{
			pContView->ColumnVisible(nColumn, bVisible);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// <<eof>> ChangeColumns.cpp
/////////////////////////////////////////////////////////////////////////////
